diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/src/traffic-control/test/codel-queue-disc-test-suite.cc ns-3.31/src/traffic-control/test/codel-queue-disc-test-suite.cc
--- ns-3.30.1/src/traffic-control/test/codel-queue-disc-test-suite.cc	2019-08-12 16:30:34.000000000 -0700
+++ ns-3.31/src/traffic-control/test/codel-queue-disc-test-suite.cc	2020-06-27 17:38:30.000000000 -0700
@@ -585,6 +587,416 @@
  * \ingroup traffic-control-test
  * \ingroup tests
  *
+ * \brief Test 6: enqueue/dequeue with marks according to CoDel algorithm
+ */
+class CoDelQueueDiscBasicMark : public TestCase
+{
+public:
+  /**
+   * Constructor
+   *
+   * \param mode the mode
+   */
+  CoDelQueueDiscBasicMark (QueueSizeUnit mode);
+  virtual void DoRun (void);
+
+private:
+  /**
+   * Enqueue function
+   * \param queue the queue disc
+   * \param size the size
+   * \param nPkt the number of packets
+   * \param ecnCapable ECN capable traffic
+   */
+  void Enqueue (Ptr<CoDelQueueDisc> queue, uint32_t size, uint32_t nPkt, bool ecnCapable);
+  /** Dequeue function
+   * \param queue the queue disc
+   * \param modeSize the mode size
+   * \param testCase the test case number
+   */
+  void Dequeue (Ptr<CoDelQueueDisc> queue, uint32_t modeSize, uint32_t testCase);
+  /**
+   * Drop next tracer function
+   * \param oldVal the old value
+   * \param newVal the new value
+   */
+  void DropNextTracer (uint32_t oldVal, uint32_t newVal);
+  QueueSizeUnit m_mode; ///< mode
+  uint32_t m_dropNextCount;    ///< count the number of times m_dropNext is recalculated
+  uint32_t nPacketsBeforeFirstDrop; ///< Number of packets in the queue before first drop
+  uint32_t nPacketsBeforeFirstMark; ///< Number of packets in the queue before first mark
+};
+
+CoDelQueueDiscBasicMark::CoDelQueueDiscBasicMark (QueueSizeUnit mode)
+  : TestCase ("Basic mark operations")
+{
+  m_mode = mode;
+  m_dropNextCount = 0;
+}
+
+void
+CoDelQueueDiscBasicMark::DropNextTracer (uint32_t oldVal, uint32_t newVal)
+{
+  NS_UNUSED(oldVal);
+  NS_UNUSED(newVal);
+  m_dropNextCount++;
+}
+
+void
+CoDelQueueDiscBasicMark::DoRun (void)
+{
+  // Test is divided into 4 sub test cases:
+  // 1) Packets are not ECN capable.
+  // 2) Packets are ECN capable but marking due to exceeding CE threshold disabled
+  // 3) Some packets are ECN capable, with CE threshold set to 2ms.
+  // 4) Packets are ECN capable and CE threshold set to 2ms
+
+  // Test case 1
+  Ptr<CoDelQueueDisc> queue = CreateObject<CoDelQueueDisc> ();
+  uint32_t pktSize = 1000;
+  uint32_t modeSize = 0;
+  nPacketsBeforeFirstDrop = 0;
+  nPacketsBeforeFirstMark = 0;
+
+  if (m_mode == QueueSizeUnit::BYTES)
+    {
+      modeSize = pktSize;
+    }
+  else if (m_mode == QueueSizeUnit::PACKETS)
+    {
+      modeSize = 1;
+    }
+
+  NS_TEST_EXPECT_MSG_EQ (queue->SetAttributeFailSafe ("MaxSize", QueueSizeValue (QueueSize (m_mode, modeSize * 500))),
+                         true, "Verify that we can actually set the attribute MaxSize");
+  NS_TEST_EXPECT_MSG_EQ (queue->SetAttributeFailSafe ("UseEcn", BooleanValue (true)),
+                         true, "Verify that we can actually set the attribute UseEcn");
+  
+  queue->Initialize ();
+
+  // Not-ECT traffic to induce packet drop
+  Enqueue (queue, pktSize, 20, false);
+  NS_TEST_EXPECT_MSG_EQ (queue->GetCurrentSize ().GetValue (), 20 * modeSize, "There should be 20 packets in queue.");
+
+  // Although the first dequeue occurs with a sojourn time above target
+  // there should not be any dropped packets in this interval
+  Time waitUntilFirstDequeue =  2 * queue->GetTarget ();
+  Simulator::Schedule (waitUntilFirstDequeue, &CoDelQueueDiscBasicMark::Dequeue, this, queue, modeSize, 1);
+
+  // This dequeue should cause a packet to be dropped
+  Time waitUntilSecondDequeue = waitUntilFirstDequeue + 2 * queue->GetInterval ();
+  Simulator::Schedule (waitUntilSecondDequeue, &CoDelQueueDiscBasicMark::Dequeue, this, queue, modeSize, 1);
+
+  Simulator::Run ();
+  Simulator::Destroy ();
+
+  // Test case 2, queue with ECN capable traffic for marking of packets instead of dropping
+  queue = CreateObject<CoDelQueueDisc> ();
+  NS_TEST_EXPECT_MSG_EQ (queue->SetAttributeFailSafe ("MaxSize", QueueSizeValue (QueueSize (m_mode, modeSize * 500))),
+                         true, "Verify that we can actually set the attribute MaxSize");
+  NS_TEST_EXPECT_MSG_EQ (queue->SetAttributeFailSafe ("UseEcn", BooleanValue (true)),
+                         true, "Verify that we can actually set the attribute UseEcn");
+
+  queue->Initialize ();
+
+  // ECN capable traffic to induce packets to be marked
+  Enqueue (queue, pktSize, 20, true);
+  NS_TEST_EXPECT_MSG_EQ (queue->GetCurrentSize ().GetValue (), 20 * modeSize, "There should be 20 packets in queue.");
+
+  // Although the first dequeue occurs with a sojourn time above target
+  // there should not be any target exceeded marked packets in this interval
+  Simulator::Schedule (waitUntilFirstDequeue, &CoDelQueueDiscBasicMark::Dequeue, this, queue, modeSize, 2);
+
+  // This dequeue should cause a packet to be marked
+  Simulator::Schedule (waitUntilSecondDequeue, &CoDelQueueDiscBasicMark::Dequeue, this, queue, modeSize, 2);
+
+  // Although we are in dropping state, it's not time for next packet to be target exceeded marked
+  // the dequeue should not cause a packet to be target exceeded marked
+  Simulator::Schedule (waitUntilSecondDequeue, &CoDelQueueDiscBasicMark::Dequeue, this, queue, modeSize, 2);
+
+  // In dropping time and it's time for next packet to be target exceeded marked
+  // the dequeue should cause additional packet to be target exceeded marked
+  Simulator::Schedule (waitUntilSecondDequeue * 2, &CoDelQueueDiscBasicMark::Dequeue, this, queue, modeSize, 2);
+
+  Simulator::Run ();
+  Simulator::Destroy ();
+
+  // Test case 3, some packets are ECN capable, with CE threshold set to 2ms
+  queue = CreateObject<CoDelQueueDisc> ();
+  NS_TEST_EXPECT_MSG_EQ (queue->SetAttributeFailSafe ("MaxSize", QueueSizeValue (QueueSize (m_mode, modeSize * 500))),
+                         true, "Verify that we can actually set the attribute MaxSize");
+  NS_TEST_EXPECT_MSG_EQ (queue->SetAttributeFailSafe ("UseEcn", BooleanValue (true)),
+                         true, "Verify that we can actually set the attribute UseEcn");
+  NS_TEST_EXPECT_MSG_EQ (queue->SetAttributeFailSafe ("CeThreshold", TimeValue (MilliSeconds (2))),
+                         true, "Verify that we can actually set the attribute CeThreshold");
+  
+  queue->Initialize ();
+
+  // First 3 packets in the queue are ecnCapable
+  Enqueue (queue, pktSize, 3, true);
+  // Rest of the packet are not ecnCapable
+  Enqueue (queue, pktSize, 17, false);
+  NS_TEST_EXPECT_MSG_EQ (queue->GetCurrentSize ().GetValue (), 20 * modeSize, "There should be 20 packets in queue.");
+
+  // Although the first dequeue occurs with a sojourn time above target
+  // there should not be any target exceeded marked packets in this interval
+  Simulator::Schedule (waitUntilFirstDequeue, &CoDelQueueDiscBasicMark::Dequeue, this, queue, modeSize, 3);
+
+  // This dequeue should cause a packet to be marked
+  Simulator::Schedule (waitUntilSecondDequeue, &CoDelQueueDiscBasicMark::Dequeue, this, queue, modeSize, 3);
+
+  // Although we are in dropping state, it's not time for next packet to be target exceeded marked
+  // the dequeue should not cause a packet to be target exceeded marked
+  Simulator::Schedule (waitUntilSecondDequeue, &CoDelQueueDiscBasicMark::Dequeue, this, queue, modeSize, 3);
+
+  // In dropping time and it's time for next packet to be dropped as packets are not ECN capable
+  // the dequeue should cause packet to be dropped
+  Simulator::Schedule (waitUntilSecondDequeue * 2, &CoDelQueueDiscBasicMark::Dequeue, this, queue, modeSize, 3);
+
+  Simulator::Run ();
+  Simulator::Destroy ();
+
+  // Test case 4, queue with ECN capable traffic and CeThreshold set for marking of packets instead of dropping
+  queue = CreateObject<CoDelQueueDisc> ();
+  NS_TEST_EXPECT_MSG_EQ (queue->SetAttributeFailSafe ("MaxSize", QueueSizeValue (QueueSize (m_mode, modeSize * 500))),
+                         true, "Verify that we can actually set the attribute MaxSize");
+  NS_TEST_EXPECT_MSG_EQ (queue->SetAttributeFailSafe ("UseEcn", BooleanValue (true)),
+                         true, "Verify that we can actually set the attribute UseEcn");
+  NS_TEST_EXPECT_MSG_EQ (queue->SetAttributeFailSafe ("CeThreshold", TimeValue (MilliSeconds (2))),
+                         true, "Verify that we can actually set the attribute CeThreshold");
+
+  queue->Initialize ();
+
+  // ECN capable traffic to induce packets to be marked
+  Enqueue (queue, pktSize, 20, true);
+  NS_TEST_EXPECT_MSG_EQ (queue->GetCurrentSize ().GetValue (), 20 * modeSize, "There should be 20 packets in queue.");
+
+  // The first dequeue occurs with a sojourn time below CE threshold
+  // there should not any be CE threshold exceeded marked packets
+  Simulator::Schedule (MilliSeconds (1), &CoDelQueueDiscBasicMark::Dequeue, this, queue, modeSize, 4);
+
+  // Sojourn time above CE threshold so this dequeue should cause a packet to be CE thershold exceeded marked
+  Simulator::Schedule (MilliSeconds (3), &CoDelQueueDiscBasicMark::Dequeue, this, queue, modeSize, 4);
+
+  // the dequeue should cause a packet to be CE threshold exceeded marked
+  Simulator::Schedule (waitUntilFirstDequeue, &CoDelQueueDiscBasicMark::Dequeue, this, queue, modeSize, 4);
+
+  // In dropping time and it's time for next packet to be dropped but because of using ECN, packet should be marked
+  Simulator::Schedule (waitUntilSecondDequeue, &CoDelQueueDiscBasicMark::Dequeue, this, queue, modeSize, 4);
+
+  Simulator::Run ();
+  Simulator::Destroy ();
+}
+
+void
+CoDelQueueDiscBasicMark::Enqueue (Ptr<CoDelQueueDisc> queue, uint32_t size, uint32_t nPkt, bool ecnCapable)
+{
+  Address dest;
+  for (uint32_t i = 0; i < nPkt; i++)
+    {
+      queue->Enqueue (Create<CodelQueueDiscTestItem> (Create<Packet> (size), dest, ecnCapable));
+    }
+}
+
+void
+CoDelQueueDiscBasicMark::Dequeue (Ptr<CoDelQueueDisc> queue, uint32_t modeSize, uint32_t testCase)
+{
+  uint32_t initialTargetMarkCount = queue->GetStats ().GetNMarkedPackets (CoDelQueueDisc::TARGET_EXCEEDED_MARK);
+  uint32_t initialCeThreshMarkCount = queue->GetStats ().GetNMarkedPackets (CoDelQueueDisc::CE_THRESHOLD_EXCEEDED_MARK);
+  uint32_t initialQSize = queue->GetCurrentSize ().GetValue ();
+  uint32_t initialDropNext = queue->GetDropNext ();
+  Time currentTime = Simulator::Now ();
+  uint32_t currentDropCount = 0;
+  uint32_t currentTargetMarkCount = 0;
+  uint32_t currentCeThreshMarkCount = 0;
+
+  if (initialTargetMarkCount > 0 && currentTime.GetMicroSeconds () >= initialDropNext && testCase == 3)
+    {
+      queue->TraceConnectWithoutContext ("DropNext", MakeCallback (&CoDelQueueDiscBasicMark::DropNextTracer, this));
+    }
+
+  if (initialQSize != 0)
+    {
+      Ptr<QueueDiscItem> item = queue->Dequeue ();
+      if (testCase == 1)
+        {
+          currentDropCount = queue->GetStats ().GetNDroppedPackets (CoDelQueueDisc::TARGET_EXCEEDED_DROP);
+          if (currentDropCount == 1)
+            {
+              nPacketsBeforeFirstDrop = initialQSize;
+            }
+        }
+      else if (testCase == 2)
+        {
+          if (initialTargetMarkCount == 0 && currentTime > queue->GetTarget ())
+            {
+              if (currentTime < queue->GetInterval ())
+                {
+                  currentDropCount = queue->GetStats ().GetNDroppedPackets (CoDelQueueDisc::TARGET_EXCEEDED_DROP);
+                  currentTargetMarkCount = queue->GetStats ().GetNMarkedPackets (CoDelQueueDisc::TARGET_EXCEEDED_MARK);
+                  currentCeThreshMarkCount = queue->GetStats ().GetNMarkedPackets (CoDelQueueDisc::CE_THRESHOLD_EXCEEDED_MARK);
+                  NS_TEST_EXPECT_MSG_EQ (queue->GetCurrentSize ().GetValue (), initialQSize - modeSize, "There should be 1 packet dequeued.");
+                  NS_TEST_EXPECT_MSG_EQ (currentDropCount, 0, "There should not be any packet drops");
+                  NS_TEST_ASSERT_MSG_EQ (currentTargetMarkCount, 0, "We are not in dropping state."
+                                        "Sojourn time has just gone above target from below."
+                                        "Hence, there should be no target exceeded marked packets");
+                  NS_TEST_ASSERT_MSG_EQ (currentCeThreshMarkCount, 0, "Marking due to CE threshold is disabled"
+                                        "Hence, there should not be any CE threshold exceeded marked packet");
+                }
+              else if (currentTime >= queue->GetInterval ())
+                {
+                  currentDropCount = queue->GetStats ().GetNDroppedPackets (CoDelQueueDisc::TARGET_EXCEEDED_DROP);
+                  currentTargetMarkCount = queue->GetStats ().GetNMarkedPackets (CoDelQueueDisc::TARGET_EXCEEDED_MARK);
+                  nPacketsBeforeFirstMark = initialQSize;
+                  currentCeThreshMarkCount = queue->GetStats ().GetNMarkedPackets (CoDelQueueDisc::CE_THRESHOLD_EXCEEDED_MARK);
+                  NS_TEST_EXPECT_MSG_EQ (queue->GetCurrentSize ().GetValue (), initialQSize - modeSize, "Sojourn time has been above target for at least interval."
+                                        "We enter the dropping state and perform initial packet marking"
+                                        "So there should be only 1 more packet dequeued.");
+                  NS_TEST_EXPECT_MSG_EQ (currentDropCount, 0, "There should not be any packet drops");
+                  NS_TEST_EXPECT_MSG_EQ (currentTargetMarkCount, 1, "There should be 1 target exceeded marked packet");
+                  NS_TEST_ASSERT_MSG_EQ (currentCeThreshMarkCount, 0, "There should not be any CE threshold exceeded marked packet");
+                }
+            }
+          else if (initialTargetMarkCount > 0)
+            { // In dropping state
+              if (currentTime.GetMicroSeconds () < initialDropNext)
+                {
+                  currentDropCount = queue->GetStats ().GetNDroppedPackets (CoDelQueueDisc::TARGET_EXCEEDED_DROP);
+                  currentTargetMarkCount = queue->GetStats ().GetNMarkedPackets (CoDelQueueDisc::TARGET_EXCEEDED_MARK);
+                  currentCeThreshMarkCount = queue->GetStats ().GetNMarkedPackets (CoDelQueueDisc::CE_THRESHOLD_EXCEEDED_MARK);
+                  NS_TEST_EXPECT_MSG_EQ (queue->GetCurrentSize ().GetValue (), initialQSize - modeSize, "We are in dropping state."
+                                        "Sojourn is still above target."
+                                        "However, it's not time for next target exceeded mark."
+                                        "So there should be only 1 more packet dequeued");
+                  NS_TEST_EXPECT_MSG_EQ (currentDropCount, 0, "There should not be any packet drops");
+                  NS_TEST_EXPECT_MSG_EQ (currentTargetMarkCount, 1, "There should still be only 1 target exceeded marked packet from the last dequeue");
+                  NS_TEST_ASSERT_MSG_EQ (currentCeThreshMarkCount, 0, "There should not be any CE threshold exceeded marked packet");
+                }
+              else if (currentTime.GetMicroSeconds () >= initialDropNext)
+                {
+                  currentDropCount = queue->GetStats ().GetNDroppedPackets (CoDelQueueDisc::TARGET_EXCEEDED_DROP);
+                  currentTargetMarkCount = queue->GetStats ().GetNMarkedPackets (CoDelQueueDisc::TARGET_EXCEEDED_MARK);
+                  currentCeThreshMarkCount = queue->GetStats ().GetNMarkedPackets (CoDelQueueDisc::CE_THRESHOLD_EXCEEDED_MARK);
+                  NS_TEST_EXPECT_MSG_EQ (queue->GetCurrentSize ().GetValue (), initialQSize - modeSize, "We are in dropping state."
+                                        "It's time for packet to be marked"
+                                        "So there should be only 1 more packet dequeued");
+                  NS_TEST_EXPECT_MSG_EQ (currentDropCount, 0, "There should not be any packet drops");
+                  NS_TEST_EXPECT_MSG_EQ (currentTargetMarkCount, 2, "There should 2 target exceeded marked packet");
+                  NS_TEST_EXPECT_MSG_EQ (nPacketsBeforeFirstDrop, nPacketsBeforeFirstMark, "Number of packets in the queue before drop should be equal"
+                                        "to number of packets in the queue before first mark as the behavior untill packet N should be the same.");
+                  NS_TEST_ASSERT_MSG_EQ (currentCeThreshMarkCount, 0, "There should not be any CE threshold exceeded marked packet");
+                }
+            }
+        }
+      else if (testCase == 3)
+        {
+          if (initialTargetMarkCount == 0 && currentTime > queue->GetTarget ())
+            {
+              if (currentTime < queue->GetInterval ())
+                {
+                  currentDropCount = queue->GetStats ().GetNDroppedPackets (CoDelQueueDisc::TARGET_EXCEEDED_DROP);
+                  currentTargetMarkCount = queue->GetStats ().GetNMarkedPackets (CoDelQueueDisc::TARGET_EXCEEDED_MARK);
+                  currentCeThreshMarkCount = queue->GetStats ().GetNMarkedPackets (CoDelQueueDisc::CE_THRESHOLD_EXCEEDED_MARK);
+                  NS_TEST_EXPECT_MSG_EQ (queue->GetCurrentSize ().GetValue (), initialQSize - modeSize, "There should be 1 packet dequeued.");
+                  NS_TEST_EXPECT_MSG_EQ (currentDropCount, 0, "There should not be any packet drops");
+                  NS_TEST_ASSERT_MSG_EQ (currentTargetMarkCount, 0, "We are not in dropping state."
+                                        "Sojourn time has just gone above target from below."
+                                        "Hence, there should be no target exceeded marked packets");
+                  NS_TEST_ASSERT_MSG_EQ (currentCeThreshMarkCount, 1, "Sojourn time has gone above CE threshold."
+                                        "Hence, there should be 1 CE threshold exceeded marked packet");
+                }
+              else if (currentTime >= queue->GetInterval ())
+                {
+                  currentDropCount = queue->GetStats ().GetNDroppedPackets (CoDelQueueDisc::TARGET_EXCEEDED_DROP);
+                  currentTargetMarkCount = queue->GetStats ().GetNMarkedPackets (CoDelQueueDisc::TARGET_EXCEEDED_MARK);
+                  currentCeThreshMarkCount = queue->GetStats ().GetNMarkedPackets (CoDelQueueDisc::CE_THRESHOLD_EXCEEDED_MARK);
+                  NS_TEST_EXPECT_MSG_EQ (queue->GetCurrentSize ().GetValue (), initialQSize - modeSize, "Sojourn time has been above target for at least interval."
+                                        "We enter the dropping state and perform initial packet marking"
+                                        "So there should be only 1 more packet dequeued.");
+                  NS_TEST_EXPECT_MSG_EQ (currentDropCount, 0, "There should not be any packet drops");
+                  NS_TEST_EXPECT_MSG_EQ (currentTargetMarkCount, 1, "There should be 1 target exceeded marked packet");
+                  NS_TEST_EXPECT_MSG_EQ (currentCeThreshMarkCount, 2, "There should be 2 CE threshold exceeded marked packets");
+                }
+            }
+          else if (initialTargetMarkCount > 0)
+            { // In dropping state
+              if (currentTime.GetMicroSeconds () < initialDropNext)
+                {
+                  currentDropCount = queue->GetStats ().GetNDroppedPackets (CoDelQueueDisc::TARGET_EXCEEDED_DROP);
+                  currentTargetMarkCount = queue->GetStats ().GetNMarkedPackets (CoDelQueueDisc::TARGET_EXCEEDED_MARK);
+                  currentCeThreshMarkCount = queue->GetStats ().GetNMarkedPackets (CoDelQueueDisc::CE_THRESHOLD_EXCEEDED_MARK);
+                  NS_TEST_EXPECT_MSG_EQ (queue->GetCurrentSize ().GetValue (), initialQSize - modeSize, "We are in dropping state."
+                                        "Sojourn is still above target."
+                                        "However, it's not time for next target exceeded mark."
+                                        "So there should be only 1 more packet dequeued");
+                  NS_TEST_EXPECT_MSG_EQ (currentDropCount, 0, "There should not be any packet drops");
+                  NS_TEST_EXPECT_MSG_EQ (currentTargetMarkCount, 1, "There should still be only 1 target exceeded marked packet from the last dequeue");
+                  NS_TEST_EXPECT_MSG_EQ (currentCeThreshMarkCount, 3, "There should be 3 CE threshold exceeded marked packets");
+                }
+              else if (currentTime.GetMicroSeconds () >= initialDropNext)
+                {
+                  currentDropCount = queue->GetStats ().GetNDroppedPackets (CoDelQueueDisc::TARGET_EXCEEDED_DROP);
+                  currentTargetMarkCount = queue->GetStats ().GetNMarkedPackets (CoDelQueueDisc::TARGET_EXCEEDED_MARK);
+                  currentCeThreshMarkCount = queue->GetStats ().GetNMarkedPackets (CoDelQueueDisc::CE_THRESHOLD_EXCEEDED_MARK);
+                  NS_TEST_EXPECT_MSG_EQ (queue->GetCurrentSize ().GetValue (), initialQSize - (m_dropNextCount + 1) * modeSize, "We are in dropping state."
+                                        "It's time for packet to be dropped as packets are not ecnCapable"
+                                        "The number of packets dequeued equals to the number of times m_dropNext is updated plus initial dequeue");
+                  NS_TEST_EXPECT_MSG_EQ (currentDropCount, m_dropNextCount, "The number of drops equals to the number of times m_dropNext is updated");
+                  NS_TEST_EXPECT_MSG_EQ (currentTargetMarkCount, 1, "There should still be only 1 target exceeded marked packet");
+                  NS_TEST_EXPECT_MSG_EQ (currentCeThreshMarkCount, 3, "There should still be 3 CE threshold exceeded marked packet as packets are not ecnCapable");
+                }
+            }
+        }
+      else if (testCase == 4)
+        {
+          if (currentTime < queue->GetTarget ())
+            {
+              if (initialCeThreshMarkCount == 0 && currentTime < MilliSeconds (2))
+                {
+                  currentDropCount = queue->GetStats ().GetNDroppedPackets (CoDelQueueDisc::TARGET_EXCEEDED_DROP);
+                  currentCeThreshMarkCount = queue->GetStats ().GetNMarkedPackets (CoDelQueueDisc::CE_THRESHOLD_EXCEEDED_MARK);
+                  NS_TEST_EXPECT_MSG_EQ (queue->GetCurrentSize ().GetValue (), initialQSize - modeSize, "There should be 1 packet dequeued.");
+                  NS_TEST_EXPECT_MSG_EQ (currentDropCount, 0, "There should not be any packet drops");
+                  NS_TEST_ASSERT_MSG_EQ (currentCeThreshMarkCount, 0, "Sojourn time has not gone above CE threshold."
+                                        "Hence, there should not be any CE threshold exceeded marked packet");
+                }
+              else
+                {
+                  currentDropCount = queue->GetStats ().GetNDroppedPackets (CoDelQueueDisc::TARGET_EXCEEDED_DROP);
+                  currentCeThreshMarkCount = queue->GetStats ().GetNMarkedPackets (CoDelQueueDisc::CE_THRESHOLD_EXCEEDED_MARK);
+                  NS_TEST_EXPECT_MSG_EQ (queue->GetCurrentSize ().GetValue (), initialQSize - modeSize, "There should be only 1 more packet dequeued.");
+                  NS_TEST_EXPECT_MSG_EQ (currentDropCount, 0, "There should not be any packet drops");
+                  NS_TEST_EXPECT_MSG_EQ (currentCeThreshMarkCount, 1, "Sojourn time has gone above CE threshold."
+                                        "There should be 1 CE threshold exceeded marked packet");
+                }
+            }
+          else if (initialCeThreshMarkCount > 0 && currentTime < queue->GetInterval ())
+            { 
+              if (initialCeThreshMarkCount < 2)
+                {
+                  currentDropCount = queue->GetStats ().GetNDroppedPackets (CoDelQueueDisc::TARGET_EXCEEDED_DROP);
+                  currentCeThreshMarkCount = queue->GetStats ().GetNMarkedPackets (CoDelQueueDisc::CE_THRESHOLD_EXCEEDED_MARK);
+                  NS_TEST_EXPECT_MSG_EQ (queue->GetCurrentSize ().GetValue (), initialQSize - modeSize, "There should be only 1 more packet dequeued.");
+                  NS_TEST_EXPECT_MSG_EQ (currentDropCount, 0, "There should not be any packet drops");
+                  NS_TEST_EXPECT_MSG_EQ (currentCeThreshMarkCount, 2, "There should be 2 CE threshold exceeded marked packets");
+                }
+              else
+                { // In dropping state
+                  currentDropCount = queue->GetStats ().GetNDroppedPackets (CoDelQueueDisc::TARGET_EXCEEDED_DROP);
+                  currentCeThreshMarkCount = queue->GetStats ().GetNMarkedPackets (CoDelQueueDisc::CE_THRESHOLD_EXCEEDED_MARK);
+                  NS_TEST_EXPECT_MSG_EQ (queue->GetCurrentSize ().GetValue (), initialQSize - modeSize, "There should be only 1 more packet dequeued.");
+                  NS_TEST_EXPECT_MSG_EQ (currentDropCount, 0, "There should not be any packet drops");
+                  NS_TEST_EXPECT_MSG_EQ (currentCeThreshMarkCount, 3, "There should be 3 CE threshold exceeded marked packet");
+                }
+            }
+        }
+    }
+}
+
+/**
+ * \ingroup traffic-control-test
+ * \ingroup tests
+ *
  * \brief CoDel Queue Disc Test Suite
  */
 static class CoDelQueueDiscTestSuite : public TestSuite
@@ -606,5 +1018,8 @@
     // Test 5: enqueue/dequeue with drops according to CoDel algorithm
     AddTestCase (new CoDelQueueDiscBasicDrop (QueueSizeUnit::PACKETS), TestCase::QUICK);
     AddTestCase (new CoDelQueueDiscBasicDrop (QueueSizeUnit::BYTES), TestCase::QUICK);
+    // Test 6: enqueue/dequeue with marks according to CoDel algorithm
+    AddTestCase (new CoDelQueueDiscBasicMark (QueueSizeUnit::PACKETS), TestCase::QUICK);
+    AddTestCase (new CoDelQueueDiscBasicMark (QueueSizeUnit::BYTES), TestCase::QUICK);
   }
 } g_coDelQueueTestSuite; ///< the test suite
diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/src/traffic-control/wscript ns-3.31/src/traffic-control/wscript
--- ns-3.30.1/src/traffic-control/wscript	2019-08-12 16:30:34.000000000 -0700
+++ ns-3.31/src/traffic-control/wscript	2020-06-27 17:38:30.000000000 -0700
@@ -40,6 +40,12 @@
       'test/cobalt-queue-disc-test-suite.cc'
         ]
 
+    # Tests encapsulating example programs should be listed here
+    if (bld.env['ENABLE_EXAMPLES']):
+        module_test.source.extend([
+        #   'test/traffic-control-examples-test-suite.cc',
+            ])
+    
     headers = bld(features='ns3header')
     headers.module = 'traffic-control'
     headers.source = [
